// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/EcuInfo.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__EcuInfo __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__EcuInfo __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EcuInfo_
{
  using Type = EcuInfo_<ContainerAllocator>;

  explicit EcuInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->version = "";
      this->mac_addr = "";
      this->config_hash = "";
      this->config_count_modified = 0;
      this->config_count_configured = 0;
      this->config_nvm_blank = false;
      this->config_nvm_write_pending = false;
      this->build_date = "";
      this->license_date = "";
      this->control_licensed = false;
    }
  }

  explicit EcuInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    name(_alloc),
    version(_alloc),
    mac_addr(_alloc),
    config_hash(_alloc),
    build_date(_alloc),
    license_date(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->version = "";
      this->mac_addr = "";
      this->config_hash = "";
      this->config_count_modified = 0;
      this->config_count_configured = 0;
      this->config_nvm_blank = false;
      this->config_nvm_write_pending = false;
      this->build_date = "";
      this->license_date = "";
      this->control_licensed = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _version_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _version_type version;
  using _mac_addr_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _mac_addr_type mac_addr;
  using _config_hash_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _config_hash_type config_hash;
  using _config_count_modified_type =
    uint8_t;
  _config_count_modified_type config_count_modified;
  using _config_count_configured_type =
    uint8_t;
  _config_count_configured_type config_count_configured;
  using _config_nvm_blank_type =
    bool;
  _config_nvm_blank_type config_nvm_blank;
  using _config_nvm_write_pending_type =
    bool;
  _config_nvm_write_pending_type config_nvm_write_pending;
  using _build_date_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _build_date_type build_date;
  using _license_date_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _license_date_type license_date;
  using _control_licensed_type =
    bool;
  _control_licensed_type control_licensed;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__version(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->version = _arg;
    return *this;
  }
  Type & set__mac_addr(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->mac_addr = _arg;
    return *this;
  }
  Type & set__config_hash(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->config_hash = _arg;
    return *this;
  }
  Type & set__config_count_modified(
    const uint8_t & _arg)
  {
    this->config_count_modified = _arg;
    return *this;
  }
  Type & set__config_count_configured(
    const uint8_t & _arg)
  {
    this->config_count_configured = _arg;
    return *this;
  }
  Type & set__config_nvm_blank(
    const bool & _arg)
  {
    this->config_nvm_blank = _arg;
    return *this;
  }
  Type & set__config_nvm_write_pending(
    const bool & _arg)
  {
    this->config_nvm_write_pending = _arg;
    return *this;
  }
  Type & set__build_date(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->build_date = _arg;
    return *this;
  }
  Type & set__license_date(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->license_date = _arg;
    return *this;
  }
  Type & set__control_licensed(
    const bool & _arg)
  {
    this->control_licensed = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__EcuInfo
    std::shared_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__EcuInfo
    std::shared_ptr<ds_dbw_msgs::msg::EcuInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EcuInfo_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->name != other.name) {
      return false;
    }
    if (this->version != other.version) {
      return false;
    }
    if (this->mac_addr != other.mac_addr) {
      return false;
    }
    if (this->config_hash != other.config_hash) {
      return false;
    }
    if (this->config_count_modified != other.config_count_modified) {
      return false;
    }
    if (this->config_count_configured != other.config_count_configured) {
      return false;
    }
    if (this->config_nvm_blank != other.config_nvm_blank) {
      return false;
    }
    if (this->config_nvm_write_pending != other.config_nvm_write_pending) {
      return false;
    }
    if (this->build_date != other.build_date) {
      return false;
    }
    if (this->license_date != other.license_date) {
      return false;
    }
    if (this->control_licensed != other.control_licensed) {
      return false;
    }
    return true;
  }
  bool operator!=(const EcuInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EcuInfo_

// alias to use template instance with default allocator
using EcuInfo =
  ds_dbw_msgs::msg::EcuInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__STRUCT_HPP_
