// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/SteeringCmd.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__SteeringCmd __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__SteeringCmd __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SteeringCmd_
{
  using Type = SteeringCmd_<ContainerAllocator>;

  explicit SteeringCmd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cmd = 0.0f;
      this->cmd_rate = 0.0f;
      this->cmd_accel = 0.0f;
      this->cmd_type = 0;
      this->enable = false;
      this->clear = false;
      this->ignore = false;
    }
  }

  explicit SteeringCmd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cmd = 0.0f;
      this->cmd_rate = 0.0f;
      this->cmd_accel = 0.0f;
      this->cmd_type = 0;
      this->enable = false;
      this->clear = false;
      this->ignore = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _cmd_type =
    float;
  _cmd_type cmd;
  using _cmd_rate_type =
    float;
  _cmd_rate_type cmd_rate;
  using _cmd_accel_type =
    float;
  _cmd_accel_type cmd_accel;
  using _cmd_type_type =
    uint8_t;
  _cmd_type_type cmd_type;
  using _enable_type =
    bool;
  _enable_type enable;
  using _clear_type =
    bool;
  _clear_type clear;
  using _ignore_type =
    bool;
  _ignore_type ignore;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__cmd(
    const float & _arg)
  {
    this->cmd = _arg;
    return *this;
  }
  Type & set__cmd_rate(
    const float & _arg)
  {
    this->cmd_rate = _arg;
    return *this;
  }
  Type & set__cmd_accel(
    const float & _arg)
  {
    this->cmd_accel = _arg;
    return *this;
  }
  Type & set__cmd_type(
    const uint8_t & _arg)
  {
    this->cmd_type = _arg;
    return *this;
  }
  Type & set__enable(
    const bool & _arg)
  {
    this->enable = _arg;
    return *this;
  }
  Type & set__clear(
    const bool & _arg)
  {
    this->clear = _arg;
    return *this;
  }
  Type & set__ignore(
    const bool & _arg)
  {
    this->ignore = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CMD_NONE =
    0u;
  static constexpr uint8_t CMD_TORQUE =
    1u;
  static constexpr uint8_t CMD_ANGLE =
    2u;
  static constexpr uint8_t CMD_CURVATURE =
    3u;
  static constexpr uint8_t CMD_YAW_RATE =
    4u;
  static constexpr uint8_t CMD_PERCENT =
    14u;
  static constexpr uint8_t CMD_CALIBRATE =
    15u;

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__SteeringCmd
    std::shared_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__SteeringCmd
    std::shared_ptr<ds_dbw_msgs::msg::SteeringCmd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SteeringCmd_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->cmd != other.cmd) {
      return false;
    }
    if (this->cmd_rate != other.cmd_rate) {
      return false;
    }
    if (this->cmd_accel != other.cmd_accel) {
      return false;
    }
    if (this->cmd_type != other.cmd_type) {
      return false;
    }
    if (this->enable != other.enable) {
      return false;
    }
    if (this->clear != other.clear) {
      return false;
    }
    if (this->ignore != other.ignore) {
      return false;
    }
    return true;
  }
  bool operator!=(const SteeringCmd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SteeringCmd_

// alias to use template instance with default allocator
using SteeringCmd =
  ds_dbw_msgs::msg::SteeringCmd_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SteeringCmd_<ContainerAllocator>::CMD_NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SteeringCmd_<ContainerAllocator>::CMD_TORQUE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SteeringCmd_<ContainerAllocator>::CMD_ANGLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SteeringCmd_<ContainerAllocator>::CMD_CURVATURE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SteeringCmd_<ContainerAllocator>::CMD_YAW_RATE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SteeringCmd_<ContainerAllocator>::CMD_PERCENT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t SteeringCmd_<ContainerAllocator>::CMD_CALIBRATE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__STEERING_CMD__STRUCT_HPP_
