// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/SystemReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__SYSTEM_REPORT__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__SYSTEM_REPORT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'system_sync_mode'
#include "ds_dbw_msgs/msg/detail/system_sync_mode__struct.h"
// Member 'state'
#include "ds_dbw_msgs/msg/detail/system_state__struct.h"
// Member 'reason_disengage_str'
// Member 'reason_not_ready_str'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/SystemReport in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__SystemReport
{
  std_msgs__msg__Header header;
  /// Inhibit control for steer/brake/throttle/gear
  bool inhibit;
  /// System parameter values
  /// Parameter ValidateCmdCrcRc value
  bool validate_cmd_crc_rc;
  /// Parameter SystemSyncMode value
  ds_dbw_msgs__msg__SystemSyncMode system_sync_mode;
  /// System state
  ds_dbw_msgs__msg__SystemState state;
  /// Status enumerations
  uint8_t reason_disengage;
  uint8_t reason_not_ready;
  rosidl_runtime_c__String reason_disengage_str;
  rosidl_runtime_c__String reason_not_ready_str;
  /// Buttons
  bool btn_enable;
  bool btn_disable;
  /// Status
  /// Any steer/brake/throttle/gear override
  bool override;
  /// All steer/brake/throttle ready, and gear not faulted
  bool ready;
  /// All steer/brake/throttle enabled, and gear not faulted (or any steer/brake/throttle enabled for Mode>=AllOrNone)
  bool enabled;
  /// Fault in any steer/brake/throttle/gear
  bool fault;
  /// CRC error in most recent system command message
  bool bad_crc;
  /// Repeated rolling counter in most recent system command message
  bool bad_rc;
} ds_dbw_msgs__msg__SystemReport;

// Struct for a sequence of ds_dbw_msgs__msg__SystemReport.
typedef struct ds_dbw_msgs__msg__SystemReport__Sequence
{
  ds_dbw_msgs__msg__SystemReport * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__SystemReport__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__SYSTEM_REPORT__STRUCT_H_
