// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/ThrottleInfo.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__THROTTLE_INFO__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__THROTTLE_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'accel_pedal_qf'
#include "ds_dbw_msgs/msg/detail/quality__struct.hpp"
// Member 'one_pedal'
#include "ds_dbw_msgs/msg/detail/one_pedal__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__ThrottleInfo __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__ThrottleInfo __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ThrottleInfo_
{
  using Type = ThrottleInfo_<ContainerAllocator>;

  explicit ThrottleInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    accel_pedal_qf(_init),
    one_pedal(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accel_pedal_pc = 0.0f;
      this->engine_rpm = 0.0f;
    }
  }

  explicit ThrottleInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    accel_pedal_qf(_alloc, _init),
    one_pedal(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accel_pedal_pc = 0.0f;
      this->engine_rpm = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _accel_pedal_pc_type =
    float;
  _accel_pedal_pc_type accel_pedal_pc;
  using _accel_pedal_qf_type =
    ds_dbw_msgs::msg::Quality_<ContainerAllocator>;
  _accel_pedal_qf_type accel_pedal_qf;
  using _one_pedal_type =
    ds_dbw_msgs::msg::OnePedal_<ContainerAllocator>;
  _one_pedal_type one_pedal;
  using _engine_rpm_type =
    float;
  _engine_rpm_type engine_rpm;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__accel_pedal_pc(
    const float & _arg)
  {
    this->accel_pedal_pc = _arg;
    return *this;
  }
  Type & set__accel_pedal_qf(
    const ds_dbw_msgs::msg::Quality_<ContainerAllocator> & _arg)
  {
    this->accel_pedal_qf = _arg;
    return *this;
  }
  Type & set__one_pedal(
    const ds_dbw_msgs::msg::OnePedal_<ContainerAllocator> & _arg)
  {
    this->one_pedal = _arg;
    return *this;
  }
  Type & set__engine_rpm(
    const float & _arg)
  {
    this->engine_rpm = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__ThrottleInfo
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__ThrottleInfo
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ThrottleInfo_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->accel_pedal_pc != other.accel_pedal_pc) {
      return false;
    }
    if (this->accel_pedal_qf != other.accel_pedal_qf) {
      return false;
    }
    if (this->one_pedal != other.one_pedal) {
      return false;
    }
    if (this->engine_rpm != other.engine_rpm) {
      return false;
    }
    return true;
  }
  bool operator!=(const ThrottleInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ThrottleInfo_

// alias to use template instance with default allocator
using ThrottleInfo =
  ds_dbw_msgs::msg::ThrottleInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__THROTTLE_INFO__STRUCT_HPP_
