// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from ds_dbw_msgs:msg/GearReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__BUILDER_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "ds_dbw_msgs/msg/detail/gear_report__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace ds_dbw_msgs
{

namespace msg
{

namespace builder
{

class Init_GearReport_cmd_src
{
public:
  explicit Init_GearReport_cmd_src(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  ::ds_dbw_msgs::msg::GearReport cmd_src(::ds_dbw_msgs::msg::GearReport::_cmd_src_type arg)
  {
    msg_.cmd_src = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_degraded
{
public:
  explicit Init_GearReport_degraded(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_cmd_src degraded(::ds_dbw_msgs::msg::GearReport::_degraded_type arg)
  {
    msg_.degraded = std::move(arg);
    return Init_GearReport_cmd_src(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_bad_crc
{
public:
  explicit Init_GearReport_bad_crc(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_degraded bad_crc(::ds_dbw_msgs::msg::GearReport::_bad_crc_type arg)
  {
    msg_.bad_crc = std::move(arg);
    return Init_GearReport_degraded(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_fault
{
public:
  explicit Init_GearReport_fault(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_bad_crc fault(::ds_dbw_msgs::msg::GearReport::_fault_type arg)
  {
    msg_.fault = std::move(arg);
    return Init_GearReport_bad_crc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_override_other
{
public:
  explicit Init_GearReport_override_other(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_fault override_other(::ds_dbw_msgs::msg::GearReport::_override_other_type arg)
  {
    msg_.override_other = std::move(arg);
    return Init_GearReport_fault(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_override_active
{
public:
  explicit Init_GearReport_override_active(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_override_other override_active(::ds_dbw_msgs::msg::GearReport::_override_active_type arg)
  {
    msg_.override_active = std::move(arg);
    return Init_GearReport_override_other(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_ready
{
public:
  explicit Init_GearReport_ready(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_override_active ready(::ds_dbw_msgs::msg::GearReport::_ready_type arg)
  {
    msg_.ready = std::move(arg);
    return Init_GearReport_override_active(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_external_control
{
public:
  explicit Init_GearReport_external_control(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_ready external_control(::ds_dbw_msgs::msg::GearReport::_external_control_type arg)
  {
    msg_.external_control = std::move(arg);
    return Init_GearReport_ready(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_power_latched
{
public:
  explicit Init_GearReport_power_latched(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_external_control power_latched(::ds_dbw_msgs::msg::GearReport::_power_latched_type arg)
  {
    msg_.power_latched = std::move(arg);
    return Init_GearReport_external_control(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_reject
{
public:
  explicit Init_GearReport_reject(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_power_latched reject(::ds_dbw_msgs::msg::GearReport::_reject_type arg)
  {
    msg_.reject = std::move(arg);
    return Init_GearReport_power_latched(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_driver
{
public:
  explicit Init_GearReport_driver(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_reject driver(::ds_dbw_msgs::msg::GearReport::_driver_type arg)
  {
    msg_.driver = std::move(arg);
    return Init_GearReport_reject(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_cmd
{
public:
  explicit Init_GearReport_cmd(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_driver cmd(::ds_dbw_msgs::msg::GearReport::_cmd_type arg)
  {
    msg_.cmd = std::move(arg);
    return Init_GearReport_driver(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_gear
{
public:
  explicit Init_GearReport_gear(::ds_dbw_msgs::msg::GearReport & msg)
  : msg_(msg)
  {}
  Init_GearReport_cmd gear(::ds_dbw_msgs::msg::GearReport::_gear_type arg)
  {
    msg_.gear = std::move(arg);
    return Init_GearReport_cmd(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

class Init_GearReport_header
{
public:
  Init_GearReport_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_GearReport_gear header(::ds_dbw_msgs::msg::GearReport::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_GearReport_gear(msg_);
  }

private:
  ::ds_dbw_msgs::msg::GearReport msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_dbw_msgs::msg::GearReport>()
{
  return ds_dbw_msgs::msg::builder::Init_GearReport_header();
}

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__BUILDER_HPP_
