// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_dbw_msgs:msg/GearReport.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/gear_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `gear`
// Member `cmd`
// Member `driver`
#include "ds_dbw_msgs/msg/detail/gear__functions.h"
// Member `reject`
#include "ds_dbw_msgs/msg/detail/gear_reject__functions.h"
// Member `cmd_src`
#include "ds_dbw_msgs/msg/detail/cmd_src__functions.h"

bool
ds_dbw_msgs__msg__GearReport__init(ds_dbw_msgs__msg__GearReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_dbw_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // gear
  if (!ds_dbw_msgs__msg__Gear__init(&msg->gear)) {
    ds_dbw_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // cmd
  if (!ds_dbw_msgs__msg__Gear__init(&msg->cmd)) {
    ds_dbw_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // driver
  if (!ds_dbw_msgs__msg__Gear__init(&msg->driver)) {
    ds_dbw_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // reject
  if (!ds_dbw_msgs__msg__GearReject__init(&msg->reject)) {
    ds_dbw_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // power_latched
  // external_control
  // ready
  // override_active
  // override_other
  // fault
  // bad_crc
  // degraded
  // cmd_src
  if (!ds_dbw_msgs__msg__CmdSrc__init(&msg->cmd_src)) {
    ds_dbw_msgs__msg__GearReport__fini(msg);
    return false;
  }
  return true;
}

void
ds_dbw_msgs__msg__GearReport__fini(ds_dbw_msgs__msg__GearReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // gear
  ds_dbw_msgs__msg__Gear__fini(&msg->gear);
  // cmd
  ds_dbw_msgs__msg__Gear__fini(&msg->cmd);
  // driver
  ds_dbw_msgs__msg__Gear__fini(&msg->driver);
  // reject
  ds_dbw_msgs__msg__GearReject__fini(&msg->reject);
  // power_latched
  // external_control
  // ready
  // override_active
  // override_other
  // fault
  // bad_crc
  // degraded
  // cmd_src
  ds_dbw_msgs__msg__CmdSrc__fini(&msg->cmd_src);
}

bool
ds_dbw_msgs__msg__GearReport__are_equal(const ds_dbw_msgs__msg__GearReport * lhs, const ds_dbw_msgs__msg__GearReport * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // gear
  if (!ds_dbw_msgs__msg__Gear__are_equal(
      &(lhs->gear), &(rhs->gear)))
  {
    return false;
  }
  // cmd
  if (!ds_dbw_msgs__msg__Gear__are_equal(
      &(lhs->cmd), &(rhs->cmd)))
  {
    return false;
  }
  // driver
  if (!ds_dbw_msgs__msg__Gear__are_equal(
      &(lhs->driver), &(rhs->driver)))
  {
    return false;
  }
  // reject
  if (!ds_dbw_msgs__msg__GearReject__are_equal(
      &(lhs->reject), &(rhs->reject)))
  {
    return false;
  }
  // power_latched
  if (lhs->power_latched != rhs->power_latched) {
    return false;
  }
  // external_control
  if (lhs->external_control != rhs->external_control) {
    return false;
  }
  // ready
  if (lhs->ready != rhs->ready) {
    return false;
  }
  // override_active
  if (lhs->override_active != rhs->override_active) {
    return false;
  }
  // override_other
  if (lhs->override_other != rhs->override_other) {
    return false;
  }
  // fault
  if (lhs->fault != rhs->fault) {
    return false;
  }
  // bad_crc
  if (lhs->bad_crc != rhs->bad_crc) {
    return false;
  }
  // degraded
  if (lhs->degraded != rhs->degraded) {
    return false;
  }
  // cmd_src
  if (!ds_dbw_msgs__msg__CmdSrc__are_equal(
      &(lhs->cmd_src), &(rhs->cmd_src)))
  {
    return false;
  }
  return true;
}

bool
ds_dbw_msgs__msg__GearReport__copy(
  const ds_dbw_msgs__msg__GearReport * input,
  ds_dbw_msgs__msg__GearReport * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // gear
  if (!ds_dbw_msgs__msg__Gear__copy(
      &(input->gear), &(output->gear)))
  {
    return false;
  }
  // cmd
  if (!ds_dbw_msgs__msg__Gear__copy(
      &(input->cmd), &(output->cmd)))
  {
    return false;
  }
  // driver
  if (!ds_dbw_msgs__msg__Gear__copy(
      &(input->driver), &(output->driver)))
  {
    return false;
  }
  // reject
  if (!ds_dbw_msgs__msg__GearReject__copy(
      &(input->reject), &(output->reject)))
  {
    return false;
  }
  // power_latched
  output->power_latched = input->power_latched;
  // external_control
  output->external_control = input->external_control;
  // ready
  output->ready = input->ready;
  // override_active
  output->override_active = input->override_active;
  // override_other
  output->override_other = input->override_other;
  // fault
  output->fault = input->fault;
  // bad_crc
  output->bad_crc = input->bad_crc;
  // degraded
  output->degraded = input->degraded;
  // cmd_src
  if (!ds_dbw_msgs__msg__CmdSrc__copy(
      &(input->cmd_src), &(output->cmd_src)))
  {
    return false;
  }
  return true;
}

ds_dbw_msgs__msg__GearReport *
ds_dbw_msgs__msg__GearReport__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__GearReport * msg = (ds_dbw_msgs__msg__GearReport *)allocator.allocate(sizeof(ds_dbw_msgs__msg__GearReport), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_dbw_msgs__msg__GearReport));
  bool success = ds_dbw_msgs__msg__GearReport__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_dbw_msgs__msg__GearReport__destroy(ds_dbw_msgs__msg__GearReport * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_dbw_msgs__msg__GearReport__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_dbw_msgs__msg__GearReport__Sequence__init(ds_dbw_msgs__msg__GearReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__GearReport * data = NULL;

  if (size) {
    data = (ds_dbw_msgs__msg__GearReport *)allocator.zero_allocate(size, sizeof(ds_dbw_msgs__msg__GearReport), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_dbw_msgs__msg__GearReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_dbw_msgs__msg__GearReport__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_dbw_msgs__msg__GearReport__Sequence__fini(ds_dbw_msgs__msg__GearReport__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_dbw_msgs__msg__GearReport__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_dbw_msgs__msg__GearReport__Sequence *
ds_dbw_msgs__msg__GearReport__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__GearReport__Sequence * array = (ds_dbw_msgs__msg__GearReport__Sequence *)allocator.allocate(sizeof(ds_dbw_msgs__msg__GearReport__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_dbw_msgs__msg__GearReport__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_dbw_msgs__msg__GearReport__Sequence__destroy(ds_dbw_msgs__msg__GearReport__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_dbw_msgs__msg__GearReport__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_dbw_msgs__msg__GearReport__Sequence__are_equal(const ds_dbw_msgs__msg__GearReport__Sequence * lhs, const ds_dbw_msgs__msg__GearReport__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_dbw_msgs__msg__GearReport__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_dbw_msgs__msg__GearReport__Sequence__copy(
  const ds_dbw_msgs__msg__GearReport__Sequence * input,
  ds_dbw_msgs__msg__GearReport__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_dbw_msgs__msg__GearReport);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_dbw_msgs__msg__GearReport * data =
      (ds_dbw_msgs__msg__GearReport *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_dbw_msgs__msg__GearReport__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_dbw_msgs__msg__GearReport__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_dbw_msgs__msg__GearReport__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
