// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_dbw_msgs:msg/SteeringReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__STEERING_REPORT__TRAITS_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__STEERING_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_dbw_msgs/msg/detail/steering_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'cmd_src'
#include "ds_dbw_msgs/msg/detail/cmd_src__traits.hpp"

namespace ds_dbw_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SteeringReport & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: steering_wheel_angle
  {
    out << "steering_wheel_angle: ";
    rosidl_generator_traits::value_to_yaml(msg.steering_wheel_angle, out);
    out << ", ";
  }

  // member: steering_column_torque
  {
    out << "steering_column_torque: ";
    rosidl_generator_traits::value_to_yaml(msg.steering_column_torque, out);
    out << ", ";
  }

  // member: cmd
  {
    out << "cmd: ";
    rosidl_generator_traits::value_to_yaml(msg.cmd, out);
    out << ", ";
  }

  // member: cmd_type
  {
    out << "cmd_type: ";
    rosidl_generator_traits::value_to_yaml(msg.cmd_type, out);
    out << ", ";
  }

  // member: limiting_value
  {
    out << "limiting_value: ";
    rosidl_generator_traits::value_to_yaml(msg.limiting_value, out);
    out << ", ";
  }

  // member: limiting_rate
  {
    out << "limiting_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.limiting_rate, out);
    out << ", ";
  }

  // member: external_control
  {
    out << "external_control: ";
    rosidl_generator_traits::value_to_yaml(msg.external_control, out);
    out << ", ";
  }

  // member: ready
  {
    out << "ready: ";
    rosidl_generator_traits::value_to_yaml(msg.ready, out);
    out << ", ";
  }

  // member: enabled
  {
    out << "enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.enabled, out);
    out << ", ";
  }

  // member: override_active
  {
    out << "override_active: ";
    rosidl_generator_traits::value_to_yaml(msg.override_active, out);
    out << ", ";
  }

  // member: override_other
  {
    out << "override_other: ";
    rosidl_generator_traits::value_to_yaml(msg.override_other, out);
    out << ", ";
  }

  // member: override_latched
  {
    out << "override_latched: ";
    rosidl_generator_traits::value_to_yaml(msg.override_latched, out);
    out << ", ";
  }

  // member: timeout
  {
    out << "timeout: ";
    rosidl_generator_traits::value_to_yaml(msg.timeout, out);
    out << ", ";
  }

  // member: fault
  {
    out << "fault: ";
    rosidl_generator_traits::value_to_yaml(msg.fault, out);
    out << ", ";
  }

  // member: bad_crc
  {
    out << "bad_crc: ";
    rosidl_generator_traits::value_to_yaml(msg.bad_crc, out);
    out << ", ";
  }

  // member: bad_rc
  {
    out << "bad_rc: ";
    rosidl_generator_traits::value_to_yaml(msg.bad_rc, out);
    out << ", ";
  }

  // member: degraded
  {
    out << "degraded: ";
    rosidl_generator_traits::value_to_yaml(msg.degraded, out);
    out << ", ";
  }

  // member: limit_rate
  {
    out << "limit_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.limit_rate, out);
    out << ", ";
  }

  // member: limit_value
  {
    out << "limit_value: ";
    rosidl_generator_traits::value_to_yaml(msg.limit_value, out);
    out << ", ";
  }

  // member: cmd_src
  {
    out << "cmd_src: ";
    to_flow_style_yaml(msg.cmd_src, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SteeringReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: steering_wheel_angle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_wheel_angle: ";
    rosidl_generator_traits::value_to_yaml(msg.steering_wheel_angle, out);
    out << "\n";
  }

  // member: steering_column_torque
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "steering_column_torque: ";
    rosidl_generator_traits::value_to_yaml(msg.steering_column_torque, out);
    out << "\n";
  }

  // member: cmd
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd: ";
    rosidl_generator_traits::value_to_yaml(msg.cmd, out);
    out << "\n";
  }

  // member: cmd_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd_type: ";
    rosidl_generator_traits::value_to_yaml(msg.cmd_type, out);
    out << "\n";
  }

  // member: limiting_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "limiting_value: ";
    rosidl_generator_traits::value_to_yaml(msg.limiting_value, out);
    out << "\n";
  }

  // member: limiting_rate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "limiting_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.limiting_rate, out);
    out << "\n";
  }

  // member: external_control
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "external_control: ";
    rosidl_generator_traits::value_to_yaml(msg.external_control, out);
    out << "\n";
  }

  // member: ready
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ready: ";
    rosidl_generator_traits::value_to_yaml(msg.ready, out);
    out << "\n";
  }

  // member: enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enabled: ";
    rosidl_generator_traits::value_to_yaml(msg.enabled, out);
    out << "\n";
  }

  // member: override_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "override_active: ";
    rosidl_generator_traits::value_to_yaml(msg.override_active, out);
    out << "\n";
  }

  // member: override_other
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "override_other: ";
    rosidl_generator_traits::value_to_yaml(msg.override_other, out);
    out << "\n";
  }

  // member: override_latched
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "override_latched: ";
    rosidl_generator_traits::value_to_yaml(msg.override_latched, out);
    out << "\n";
  }

  // member: timeout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timeout: ";
    rosidl_generator_traits::value_to_yaml(msg.timeout, out);
    out << "\n";
  }

  // member: fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fault: ";
    rosidl_generator_traits::value_to_yaml(msg.fault, out);
    out << "\n";
  }

  // member: bad_crc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bad_crc: ";
    rosidl_generator_traits::value_to_yaml(msg.bad_crc, out);
    out << "\n";
  }

  // member: bad_rc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bad_rc: ";
    rosidl_generator_traits::value_to_yaml(msg.bad_rc, out);
    out << "\n";
  }

  // member: degraded
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "degraded: ";
    rosidl_generator_traits::value_to_yaml(msg.degraded, out);
    out << "\n";
  }

  // member: limit_rate
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "limit_rate: ";
    rosidl_generator_traits::value_to_yaml(msg.limit_rate, out);
    out << "\n";
  }

  // member: limit_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "limit_value: ";
    rosidl_generator_traits::value_to_yaml(msg.limit_value, out);
    out << "\n";
  }

  // member: cmd_src
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd_src:\n";
    to_block_style_yaml(msg.cmd_src, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SteeringReport & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_dbw_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_dbw_msgs::msg::SteeringReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_dbw_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_dbw_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ds_dbw_msgs::msg::SteeringReport & msg)
{
  return ds_dbw_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ds_dbw_msgs::msg::SteeringReport>()
{
  return "ds_dbw_msgs::msg::SteeringReport";
}

template<>
inline const char * name<ds_dbw_msgs::msg::SteeringReport>()
{
  return "ds_dbw_msgs/msg/SteeringReport";
}

template<>
struct has_fixed_size<ds_dbw_msgs::msg::SteeringReport>
  : std::integral_constant<bool, has_fixed_size<ds_dbw_msgs::msg::CmdSrc>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<ds_dbw_msgs::msg::SteeringReport>
  : std::integral_constant<bool, has_bounded_size<ds_dbw_msgs::msg::CmdSrc>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<ds_dbw_msgs::msg::SteeringReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DS_DBW_MSGS__MSG__DETAIL__STEERING_REPORT__TRAITS_HPP_
