// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/ThrottleReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'cmd_src'
#include "ds_dbw_msgs/msg/detail/cmd_src__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__ThrottleReport __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__ThrottleReport __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ThrottleReport_
{
  using Type = ThrottleReport_<ContainerAllocator>;

  explicit ThrottleReport_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    cmd_src(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cmd_type = 0;
      this->percent_input = 0.0f;
      this->percent_cmd = 0.0f;
      this->percent_output = 0.0f;
      this->limiting_value = false;
      this->limiting_rate = false;
      this->external_control = false;
      this->ready = false;
      this->enabled = false;
      this->override_active = false;
      this->override_other = false;
      this->override_latched = false;
      this->timeout = false;
      this->fault = false;
      this->bad_crc = false;
      this->bad_rc = false;
      this->degraded = false;
      this->limit_value = 0.0f;
    }
  }

  explicit ThrottleReport_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    cmd_src(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cmd_type = 0;
      this->percent_input = 0.0f;
      this->percent_cmd = 0.0f;
      this->percent_output = 0.0f;
      this->limiting_value = false;
      this->limiting_rate = false;
      this->external_control = false;
      this->ready = false;
      this->enabled = false;
      this->override_active = false;
      this->override_other = false;
      this->override_latched = false;
      this->timeout = false;
      this->fault = false;
      this->bad_crc = false;
      this->bad_rc = false;
      this->degraded = false;
      this->limit_value = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _cmd_type_type =
    uint8_t;
  _cmd_type_type cmd_type;
  using _percent_input_type =
    float;
  _percent_input_type percent_input;
  using _percent_cmd_type =
    float;
  _percent_cmd_type percent_cmd;
  using _percent_output_type =
    float;
  _percent_output_type percent_output;
  using _limiting_value_type =
    bool;
  _limiting_value_type limiting_value;
  using _limiting_rate_type =
    bool;
  _limiting_rate_type limiting_rate;
  using _external_control_type =
    bool;
  _external_control_type external_control;
  using _ready_type =
    bool;
  _ready_type ready;
  using _enabled_type =
    bool;
  _enabled_type enabled;
  using _override_active_type =
    bool;
  _override_active_type override_active;
  using _override_other_type =
    bool;
  _override_other_type override_other;
  using _override_latched_type =
    bool;
  _override_latched_type override_latched;
  using _timeout_type =
    bool;
  _timeout_type timeout;
  using _fault_type =
    bool;
  _fault_type fault;
  using _bad_crc_type =
    bool;
  _bad_crc_type bad_crc;
  using _bad_rc_type =
    bool;
  _bad_rc_type bad_rc;
  using _degraded_type =
    bool;
  _degraded_type degraded;
  using _limit_value_type =
    float;
  _limit_value_type limit_value;
  using _cmd_src_type =
    ds_dbw_msgs::msg::CmdSrc_<ContainerAllocator>;
  _cmd_src_type cmd_src;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__cmd_type(
    const uint8_t & _arg)
  {
    this->cmd_type = _arg;
    return *this;
  }
  Type & set__percent_input(
    const float & _arg)
  {
    this->percent_input = _arg;
    return *this;
  }
  Type & set__percent_cmd(
    const float & _arg)
  {
    this->percent_cmd = _arg;
    return *this;
  }
  Type & set__percent_output(
    const float & _arg)
  {
    this->percent_output = _arg;
    return *this;
  }
  Type & set__limiting_value(
    const bool & _arg)
  {
    this->limiting_value = _arg;
    return *this;
  }
  Type & set__limiting_rate(
    const bool & _arg)
  {
    this->limiting_rate = _arg;
    return *this;
  }
  Type & set__external_control(
    const bool & _arg)
  {
    this->external_control = _arg;
    return *this;
  }
  Type & set__ready(
    const bool & _arg)
  {
    this->ready = _arg;
    return *this;
  }
  Type & set__enabled(
    const bool & _arg)
  {
    this->enabled = _arg;
    return *this;
  }
  Type & set__override_active(
    const bool & _arg)
  {
    this->override_active = _arg;
    return *this;
  }
  Type & set__override_other(
    const bool & _arg)
  {
    this->override_other = _arg;
    return *this;
  }
  Type & set__override_latched(
    const bool & _arg)
  {
    this->override_latched = _arg;
    return *this;
  }
  Type & set__timeout(
    const bool & _arg)
  {
    this->timeout = _arg;
    return *this;
  }
  Type & set__fault(
    const bool & _arg)
  {
    this->fault = _arg;
    return *this;
  }
  Type & set__bad_crc(
    const bool & _arg)
  {
    this->bad_crc = _arg;
    return *this;
  }
  Type & set__bad_rc(
    const bool & _arg)
  {
    this->bad_rc = _arg;
    return *this;
  }
  Type & set__degraded(
    const bool & _arg)
  {
    this->degraded = _arg;
    return *this;
  }
  Type & set__limit_value(
    const float & _arg)
  {
    this->limit_value = _arg;
    return *this;
  }
  Type & set__cmd_src(
    const ds_dbw_msgs::msg::CmdSrc_<ContainerAllocator> & _arg)
  {
    this->cmd_src = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__ThrottleReport
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__ThrottleReport
    std::shared_ptr<ds_dbw_msgs::msg::ThrottleReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ThrottleReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->cmd_type != other.cmd_type) {
      return false;
    }
    if (this->percent_input != other.percent_input) {
      return false;
    }
    if (this->percent_cmd != other.percent_cmd) {
      return false;
    }
    if (this->percent_output != other.percent_output) {
      return false;
    }
    if (this->limiting_value != other.limiting_value) {
      return false;
    }
    if (this->limiting_rate != other.limiting_rate) {
      return false;
    }
    if (this->external_control != other.external_control) {
      return false;
    }
    if (this->ready != other.ready) {
      return false;
    }
    if (this->enabled != other.enabled) {
      return false;
    }
    if (this->override_active != other.override_active) {
      return false;
    }
    if (this->override_other != other.override_other) {
      return false;
    }
    if (this->override_latched != other.override_latched) {
      return false;
    }
    if (this->timeout != other.timeout) {
      return false;
    }
    if (this->fault != other.fault) {
      return false;
    }
    if (this->bad_crc != other.bad_crc) {
      return false;
    }
    if (this->bad_rc != other.bad_rc) {
      return false;
    }
    if (this->degraded != other.degraded) {
      return false;
    }
    if (this->limit_value != other.limit_value) {
      return false;
    }
    if (this->cmd_src != other.cmd_src) {
      return false;
    }
    return true;
  }
  bool operator!=(const ThrottleReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ThrottleReport_

// alias to use template instance with default allocator
using ThrottleReport =
  ds_dbw_msgs::msg::ThrottleReport_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__THROTTLE_REPORT__STRUCT_HPP_
